%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%                      IMPLICITNI QR-ALGORITMUS: 
%    konvergence pro Rayleighuv shift, srovnani s expl. variantou
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% EXPLICITNI QR-ALGORITMUS S REYL. SHIFTEM (z minula)

A=gallery(3);                        % testovaci matice s vl. c. 1, 2, 3
eig(A)
[P,H] = hess(A);                     % prevedeni na horni Hess. tvar
 
[R1,err1,lambda1]=explQR_shift(H,10);     

subplot(2,1,1)                       % nejm. vl. c. konverguje rychle
semilogy(err1,'m')                   % chyba aproximace
subplot(2,1,2)
plot(lambda1,'mo')                   % aproximace
pause

R1                                   % sledujte aproximaci vsech vl. c.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% IMPLICITNI QR-ALGORITMUS

help createbulge                     % vytvori 'hrbol'
help bulgechasing                    % pomoci Giv. rotaci odsune hrbol

A = rand(10,10);
[P,H] = hess(A);                     % Hessenberguv tvar
n=size(A,1);

figure(2)
spy(H)

B = createbulge(H,H(n,n));           % sledujte zaplneni prvku B(3,2)
spy(B)

B = bulgechasing(B);                 % sledujte prubezne posunovani hrbolu


%% naprogramujte implicitni QR-algoritmus
% -> vyuzijte funkci 'createbulge', 'bulgechasing' 

A=gallery(3);                        % testovaci matice s vl. c. 1, 2, 3
eig(A)
[P,H] = hess(A);

[R2,err2,lambda2]=implQR_shift(H,10);       % konverguje rychle

figure(1)
subplot(2,1,1)
hold on
semilogy(err2,'b') 
subplot(2,1,2)
hold on
plot(lambda2,'b*')

% porovnejte s konvergenci expl. QR-algoritmu

%% testujte dalsi matice z minule hodiny:

% Priklad 2: D = diag([4 3 2 1]); S=rand(4); A = S*D/S;

% Priklad 3: D = diag([4 3 -1 1]); S=rand(4); A = S*D/S; 




