function [c,s]=giv(x)
% function [c,s] = giv(x)
%
% A real or complex Givens rotation that zeros out the second entry of 
% the vector x = [x1,x2] 

nrm = norm(x);
if imag(x) == 0
c = x(1)/nrm;
s = -x(2)/nrm;
else
c = abs(x(1))/nrm; 
s = -exp(-i*angle(x(1)))*x(2)/nrm; 
end