function [R,err,lambda_n] = implQR_shift(A,m)
% implicit QR-algorithm with Rayleigh shift
%   Input:  A - matrix
%           m - number of iterations
%   Output: R - upper triangular matrix
%           err - velikosti prvku A(n,n-1)
%           lambda_n - aproximace nejmensiho vl.c.

n = size(A,1);
err = [abs(A(n,n-1))];
lambda_n = A(n,n);                      % Reyl. shift

for i=1:m,
    A = createbulge(A,lambda_n(i));
    A = bulgechasing(A);
    
    err = [err,abs(A(n,n-1))];
    lambda_n = [lambda_n, A(n,n)];
end

R=A

